#%define ffmpegsvn		20061030
%define cvs cvs14
%define with_optimization	1
%define with_debug 		0
%define with_xinerama 		1
%define with_xvideo 		1
%define with_ogg 		1
%define with_xvid 		1
%define with_ffmpeg 		1
%define with_ffmpeg_optim	1
%define with_ffmpeg_amrnb	0
%define with_ffmpeg_amrnb_fixed	0
%define with_ffmpeg_amrwb	0
%define with_lame 		1
%define with_faac 		1
%define with_dvb 		1
%define with_zvbi 		1
%define with_lirc 		1
%define with_alsa 		1
%define with_png 		1
%define with_jpeg 		1

#without
%{?_without_optimization: 	%{expand: %%global with_optimization 0}}
%{?_without_debug: 		%{expand: %%global with_debug 0}}
%{?_without_xinerama: 		%{expand: %%global with_xinerama 0}}
%{?_without_xvideo: 		%{expand: %%global with_xvideo 0}}
%{?_without_ogg: 		%{expand: %%global with_ogg 0}}
%{?_without_xvid: 		%{expand: %%global with_xvid 0}}
%{?_without_ffmpeg: 		%{expand: %%global with_ffmpeg 0}}
%{?_without_ffmpeg_optim: 	%{expand: %%global with_ffmpeg_optim 0}}
%{?_without_ffmpeg_amrnb:	%{expand: %%global with_ffmpeg_amrnb 0}}
%{?_without_ffmpeg_amrnb_fixed:	%{expand: %%global with_ffmpeg_amrnb_fixed 0}}
%{?_without_ffmpeg_amrwb:	%{expand: %%global with_ffmpeg_amrwb 0}}
%{?_without_lame: 		%{expand: %%global with_lame 0}}
%{?_without_faac: 		%{expand: %%global with_faac 0}}
%{?_without_dvb: 		%{expand: %%global with_dvb 0}}
%{?_without_zvbi: 		%{expand: %%global with_zvbi 0}}
%{?_without_lirc: 		%{expand: %%global with_lirc 0}}
%{?_without_alsa: 		%{expand: %%global with_alsa 0}}
%{?_without_png: 		%{expand: %%global with_png 0}}
%{?_without_jpeg: 		%{expand: %%global with_jpeg 0}}

#with
%{?_with_optimization: 		%{expand: %%global with_optimization 1}}
%{?_with_debug: 		%{expand: %%global with_debug 1}}
%{?_with_xinerama: 		%{expand: %%global with_xinerama 1}}
%{?_with_xvideo: 		%{expand: %%global with_xvideo 1}}
%{?_with_ogg: 			%{expand: %%global with_ogg 1}}
%{?_with_xvid: 			%{expand: %%global with_xvid 1}}
%{?_with_ffmpeg: 		%{expand: %%global with_ffmpeg 1}}
%{?_with_ffmpeg_optim: 		%{expand: %%global with_ffmpeg_optim 1}}
%{?_with_ffmpeg_amrnb: 		%{expand: %%global with_ffmpeg_amrnb 1}}
%{?_with_ffmpeg_amrnb_fixed: 	%{expand: %%global with_ffmpeg_amrnb_fixed 1}}
%{?_with_ffmpeg_amrwb: 		%{expand: %%global with_ffmpeg_amrwb 1}}
%{?_with_lame: 			%{expand: %%global with_lame 1}}
%{?_with_faac: 			%{expand: %%global with_faac 1}}
%{?_with_dvb: 			%{expand: %%global with_dvb 1}}
%{?_with_zvbi: 			%{expand: %%global with_zvbi 1}}
%{?_with_lirc: 			%{expand: %%global with_lirc 1}}
%{?_with_alsa: 			%{expand: %%global with_alsa 1}}
%{?_with_png: 			%{expand: %%global with_png 1}}
%{?_with_jpeg: 			%{expand: %%global with_jpeg 1}}

Name:           xdtv
Version:        2.4.1
Release:        0.2%{?cvs}%{?dist}
Summary:        Video4Linux Stream Capture Viewer & Recorder

Group:          Applications/Multimedia
License:        GPLv2+
URL:            http://xawdecode.sourceforge.net/
Source0:        http://downloads.sourceforge.net/xawdecode/xdtv-%{version}%{?cvs}.tar.gz
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)


BuildRequires:  texi2html
BuildRequires:  faad2-devel
BuildRequires:  imlib2-devel
BuildRequires:  xterm
BuildRequires:  yasm
BuildRequires:  xorg-x11-font-utils
BuildRequires:  xorg-x11-server-utils

#BuildRequires:	ffmpeg-devel
BuildRequires:  libX11-devel
BuildRequires:  libXext-devel
BuildRequires:  libXmu-devel
BuildRequires:  libXt-devel
BuildRequires:  libXxf86dga-devel
BuildRequires:  libXxf86vm-devel
BuildRequires:  libXpm-devel
BuildRequires:  desktop-file-utils
%if %with_xinerama
BuildRequires:  libXinerama-devel
%endif
%if %with_xvideo
BuildRequires:  libXv-devel
%endif
%if %with_xvid
BuildRequires:  xvidcore-devel
%endif
%if %with_faac
BuildRequires:  faac-devel
%endif
%{?_with_x264:BuildRequires: BuildRequires:  x264-devel}
%if %with_lame
BuildRequires:  lame-devel
%endif
%if %with_zvbi
BuildRequires:  zvbi-devel
%endif
%if %with_lirc
BuildRequires:  lirc-devel
%endif
%if %with_jpeg
BuildRequires:  libjpeg-devel
%endif
%if %with_png
BuildRequires:  libpng-devel
%endif
%if %with_ogg
BuildRequires:  libtheora-devel >= 1.0alpha5
BuildRequires:  libvorbis-devel >= 1.1.0
BuildRequires:  libogg-devel >= 1.1.2
%endif
%if %with_alsa
BuildRequires:  alsa-lib-devel
%endif
BuildRequires:  neXtaw-devel
%if %with_dvb
BuildRequires:  SDL-devel
BuildRequires:  curl-devel
%endif
BuildRequires:  dbus-devel
BuildRequires:  dbus-glib-devel
BuildRequires:  yasm

#Needed for consolehelper
Requires: usermode


%description
XdTV is a software that allows you to to record & watch TV.
It interacts with AleVT for Teletext and Nxtvepg for NextView,
and uses the video4linux API. It can use some deinterlacing filters
and can record video files in various containers (AVI, MPEG, OGG, etc.) 
with many codecs (FFMpeg(>=0.4.6), XviD(0.9 & 1.x),
Ogg Theora (>=1.0alpha5) & Vorbis and DivX4/5).
It has also some plugin capabilities.

%package        devel
Summary:        Developpement files for %{name}
Group:          Development/Libraries
Requires:       %{name} = %{version}-%{release}

%description    devel
Developpement files for %{name}

%package        OSD-font
Summary:        Font used by %{name} OSD function
Group:          User Interface/X
Requires:       %{name} = %{version}-%{release}

%description    OSD-font
Font used by %{name} OSD function.

# -----------------------------------------------------------------------------

%prep
%setup -q -n %{name}-%{version}%{?cvs}

# fix flags
sed -i -e 's|PERF_FLAGS =|PERF_FLAGS = $(CFLAGS) \n#PERF_FLAGS =|' src/Makefile.am src/Makefile.in

# Fix plugdir for lib64
sed -i -e  's|lib/xdtv-plugins|%{_lib}/xdtv-plugins|' src/plugin.c

# Convert not UTF-8 files
mkdir -p __temp
for f in README.ffmpeg README.lirc README.xvid FAQfr-xdtv ;do
cp -p $f __temp/$f
iconv -f ISO-8859-1 -t UTF-8 __temp/$f > $f
touch -r __temp/$f $f
done
rm -rf __temp

#Fix for alevtparams_ui.c
sed -i.neXtaw -e 's|X11/Xaw|X11/neXtaw|g' src/*.{c,h} src/devicemanager/devicemanager_ui.c


# -----------------------------------------------------------------------------

%build
%configure --disable-divx4linux --disable-static --with-fontdir=%{_datadir}/X11/fonts/misc --enable-pixmaps \
%if %with_optimization 
	--enable-cpu-detection \
%else
	--disable-cpu-detection \
%endif
%if %with_debug
	--disable-nodebug \
%else
	--enable-nodebug \
%endif
%if %with_xinerama
	--enable-xinerama \
%else
	--disable-xinerama \
%endif
%if %with_xvideo
	--enable-xvideo \
%else
	--disable-xvideo \
%endif
%if %with_ogg
	--enable-ogg \
%else
	--disable-ogg \
%endif
%if %with_xvid
	--enable-xvid \
%else
	--disable-xvid \
%endif
%if %with_ffmpeg
	--enable-ffmpeg --enable-ffmpeg-swscale \
  %if %with_ffmpeg_optim 
	--enable-mmx --enable-mmx2 --enable-sse3 --enable-ebp --enable-ebx \
  %endif
  %if %with_ffmpeg_amrnb
	--enable-ffmpeg-amrnb \
  %else
	--disable-ffmpeg-amrnb \
  %endif
  %if %with_ffmpeg_amrnb_fixed
	--enable-ffmpeg-amrnb-fixed \
  %else
	--disable-ffmpeg-amrnb-fixed \
  %endif
  %if %with_ffmpeg_amrwb
	--enable-ffmpeg-amrwb \
  %else
	--disable-ffmpeg-amrwb \
  %endif
%else
	--disable-ffmpeg \
%endif
%if %with_lame
	--enable-lame \
%else
	--disable-lame \
%endif
%if %with_faac
	--enable-faac \
%else
	--disable-faac \
%endif
%{?_with_x264:--enable-x264}%{!?_with_x264:--disable-x264}  \
%if %with_zvbi
	--enable-zvbi \
%else
	--disable-zvbi \
%endif
%if %with_lirc
	--enable-lirc \
%else
	--disable-lirc \
%endif
%if %with_dvb
	--enable-dvb \
%else
	--disable-dvb \
%endif
%if %with_alsa
	--enable-alsa \
%else
	--disable-alsa \
%endif
%if %with_jpeg
	--enable-jpeg \
%else
	--disable-jpeg \
%endif
%if %with_png
	--enable-png \
%else
	--disable-png \
%endif
	--with-dbus



make %{?_smp_mflags}

# -----------------------------------------------------------------------------

%install
rm -rf $RPM_BUILD_ROOT
make DESTDIR="$RPM_BUILD_ROOT" INSTALL="install -p " install
find $RPM_BUILD_ROOT -type f -name "*.la" -exec rm -f {} ';'

# Make xdtv owns the plugin dir
mkdir -p $RPM_BUILD_ROOT%{_libdir}/xdtv-plugins

# Make xdtv owns the locales dir
mkdir -p $RPM_BUILD_ROOT%{_libdir}/xdtv

# remove the setuid root of this file (need to be root to use it)
chmod 0755 $RPM_BUILD_ROOT%{_bindir}/xdtv_v4l-conf

# xdtv_v4l-conf  stuff - inspired from xawtv

mkdir -p $RPM_BUILD_ROOT%{_sbindir} \
	$RPM_BUILD_ROOT%{_sysconfdir}/pam.d \
	$RPM_BUILD_ROOT%{_sysconfdir}/security/console.apps \

cat >xdtv_v4l-conf.pam <<!
#%PAM-1.0
auth		sufficient	pam_rootok.so
auth		required	pam_console.so
account		required	pam_permit.so
session		required	pam_permit.so
session		optional	pam_xauth.so
!
install -m 0644 xdtv_v4l-conf.pam $RPM_BUILD_ROOT%{_sysconfdir}/pam.d/xdtv_v4l-conf

cat >xdtv_v4l-conf.apps <<!
SESSION=true
USER=root
PROGRAM=%{_sbindir}/xdtv_v4l-conf
!
install -m 0644 xdtv_v4l-conf.apps $RPM_BUILD_ROOT%{_sysconfdir}/security/console.apps/xdtv_v4l-conf

mv $RPM_BUILD_ROOT%{_bindir}/xdtv_v4l-conf $RPM_BUILD_ROOT%{_sbindir}/
ln -s consolehelper $RPM_BUILD_ROOT%{_bindir}/xdtv_v4l-conf

# Deprecated
rm -rf $RPM_BUILD_ROOT%{_datadir}/X11/fonts/misc/fonts.dir
rm -rf $RPM_BUILD_ROOT%{_datadir}/X11/fonts/misc/fonts.scale

#Icons
for i in 16 32 48 ; do
  mkdir -p $RPM_BUILD_ROOT%{_datadir}/icons/hicolor/${i}x${i}/apps
  install -pm 0644 %{name}-${i}.png \
    $RPM_BUILD_ROOT%{_datadir}/icons/hicolor/${i}x${i}/apps/%{name}.png
done

#Desktop
mkdir -p $RPM_BUILD_ROOT%{_datadir}/applications

%{__cat} <<EOF >xdtv.desktop
[Desktop Entry]
Name=XdTV
Comment=Capture View & Broadcast Video4Linux Streams
Comment[fr]=Capturer Visualiser & Diffuser des flux v4l
Exec=xdtv
Icon=xdtv
Terminal=false
Type=Application
Categories=AudioVideo;
EOF

desktop-file-install --delete-original \
--vendor "" \
--dir $RPM_BUILD_ROOT%{_datadir}/applications \
--mode 0644 \
xdtv.desktop

%{__cat} <<EOF >xdtv_wizard.desktop
[Desktop Entry]
Name=XdTV Wizard
Comment=XdTV Wizard
Exec=xdtv_wizard
Icon=xdtv
Terminal=false
Type=Application
Categories=AudioVideo;
EOF

desktop-file-install --delete-original \
--vendor "" \
--dir $RPM_BUILD_ROOT%{_datadir}/applications \
--mode 0644 \
xdtv_wizard.desktop



# -----------------------------------------------------------------------------

%clean
rm -rf $RPM_BUILD_ROOT

# -----------------------------------------------------------------------------

%post
touch --no-create %{_datadir}/icons/hicolor
if [ -x %{_bindir}/gtk-update-icon-cache ]; then
  %{_bindir}/gtk-update-icon-cache --quiet %{_datadir}/icons/hicolor
fi 
%{_bindir}/update-desktop-database %{_datadir}/applications || :

%postun
%{_bindir}/update-desktop-database %{_datadir}/applications
touch --no-create %{_datadir}/icons/hicolor
if [ -x %{_bindir}/gtk-update-icon-cache ]; then
  %{_bindir}/gtk-update-icon-cache --quiet %{_datadir}/icons/hicolor
fi || :


%post OSD-font
if [ -x %{_bindir}/fc-cache ]; then
   %{_bindir}/fc-cache %{_datadir}/X11/fonts/misc
fi

%postun OSD-font
if [ "$1" = "0" ]; then
   if [ -x %{_bindir}/fc-cache ]; then
      %{_bindir}/fc-cache %{_datadir}/X11/fonts/misc
   fi
fi

%files
%defattr(-,root,root,-)
%doc AUTHORS COPYING INSTALL FAQfr-xdtv TODO
%doc README README.dvb README.record README.bs README.ffmpeg README.streaming
%doc README.bsd README.gentoo README.xvid README.buildme README.lirc
%doc README.deinterlace README.plugins ChangeLog lisez-moi xdtvrc.sample
%doc lircrc.miro.sample lircrc.hauppauge.sample lircrc.animax.sample
%doc lircrc.WinfastTV2000.sample
%{_sbindir}/xdtv_v4l-conf
%{_bindir}/xdtv*
%{_datadir}/X11/app-defaults/XdTV
%config %{_sysconfdir}/pam.d/xdtv_v4l-conf
%config %{_sysconfdir}/security/console.apps/xdtv_v4l-conf
%config %{_sysconfdir}/xdtv/%{name}_wizard-en.conf
%config %{_sysconfdir}/xdtv/%{name}_wizard-en-UTF8.conf
%{_datadir}/icons/hicolor/*/apps/%{name}.png
%{_datadir}/xdtv/
%{_datadir}/applications/*xdtv.desktop
%{_datadir}/applications/*xdtv_wizard.desktop
%{_mandir}/man1/*.1.gz
# Directory for plugins
%dir %{_libdir}/xdtv-plugins
# Directory for locales
%dir %{_libdir}/xdtv

%files devel
%defattr(-,root,root,-)
%{_includedir}/%{name}/

%files OSD-font
%defattr(-,root,root,-)
%{_datadir}/X11/fonts/misc/*.pcf.gz


%changelog
* Mon Jan  5 2009 kwizart < kwizart at gmail.com > - 2.4.1-0.2cvs14
- Update to 2.4.1cvs14

* Mon Oct 14 2008 kwizart < kwizart at gmail.com > - 2.4.1-0.2cvs13
- Add PAM support - picked from xawtv
  (instead of having xdtv_v4l-conf to be setuid root)
- Re-order configure options
- Only use neXtaw instead of Xaw

* Mon Sep 29 2008 kwizart < kwizart at gmail.com > - 2.4.1-0.1cvs13
- Update to 2.4.1cvs13

* Thu Aug 28 2008 kwizart < kwizart at gmail.com > - 2.4.1-0.1cvs12
- Update to 2.4.1cvs12

* Tue Mar 25 2008 kwizart < kwizart at gmail.com > - 2.4.1-0.1cvs8
- Update to 2.4.1cvs8

* Sat Jan 12 2008 kwizart < kwizart at gmail.com > - 2.4.1-0.1cvs5
- Update to 2.4.1cvs5

* Thu Dec  6 2007 kwizart < kwizart at gmail.com > - 2.4.1-0.1cvs4
- Update to 2.4.1cvs4

* Wed Nov  7 2007 kwizart < kwizart at gmail.com > - 2.4.1-0.1cvs3
- Update to 2.4.1cvs3

* Thu Oct 25 2007 kwizart < kwizart at gmail.com > - 2.4.1-0.1cvs2
- Update to pre 2.4.1 cvs2
- Fix the plugin directory on lib64
- Remove info post postun

* Mon Feb 27 2007 kwizart < kwizart at gmail.com > - 2.4.0-1
- Update to final 2.4.0
- remove desktop file vendor and add category

* Mon Feb 05 2007 kwizart < kwizart at gmail.com > - 2.4.0-0.10.pre0
- Fix compile flags

* Wed Jan  3 2007 kwizart < kwizart at gmail.com > - 2.4.0-0.9.pre0
- ffmpeg-rebuild
- some patches from gentoo
- conform to versioning guidelines
- tweak some includes in divx.h
- Enabled Optimization

* Sun Dec 17 2006 kwizart < kwizart at gmail.com > 2.4.0pre0-8.kwizart.fc6
- Try to use ffmpeg-amr-devel with static lib with xdtv

* Sun Dec 10 2006 kwizart < kwizart at gmail.com > 0:2.4.0pre0-7.kwizart.fc6
- Cleaned spec file.

* Sat Nov 11 2006 kwizart < kwizart at gmail.com > 0:2.4.0pre0-6.kwizart.fc6
- libdir in configure.
- cleaned spec file for livna.org.
- Now use updated ffmpeg tarball from livna 20061030 src.rpm.
- Re-use x264 from livna.

* Wed Nov 06 2006 kwizart < kwizart at gmail.com > - 0:2.4.0pre0-5.kwizart.fc6
- New release for fc6

* Tue Oct 17 2006 kwizart < kwizart at gmail.com > - 0:2.4.0pre0-4.kwizart.FC5
- dropped x264 - recent x264 version won't build with xdtv
- man files are in correct place.

* Sat Sep 22 2006 kwizart < kwizart at gmail.com > - 0:2.4.0pre0-3.kwizart.FC5
- amr support (amrnb_float amrwb_float).

* Sun Sep 16 2006 kwizart < kwizart at gmail.com > - 0:2.4.0pre0-2.kwizart.FC5
- Cleaned $RPM_BUILD_ROOT tags / 
- Problem with application cache / fixed?

* Fri Aug 04 2006 kwizart < kwizart at gmail.com >
- switch to livna release

* Sat Mar 25 2006 Sir Pingus <pingus_77@yahoo.fr> 2.3.2-1fc5
- 2.3.2 on FC5
- The system app-defaults/ directory for X resources is now /usr/share/X11/app-defaults/ 
  on Fedora Core 5 and for future Red Hat Enterprise Linux systems.
- FC5 has modular X. All the libraries that were in xorg-x11-devel now have their own packages 
  and you need to include the -devel packages for the libraries your project is actually using.
- all infos here: http://fedora.redhat.com/docs/release-notes/fc5/
- new paths for desktop icons & TV misc fonts & font utils

* Sun Mar 19 2006 Sir Pingus <pingus_77@yahoo.fr> 2.3.2-1fc4
- 2.3.2
- fix error with the instalation of the TV fonts (need chkfontpath).
- fix error with the path of the ressource file (not the same path than in a Mandriva distro).
- fix error with the menu update (the menu was not updated).
- fix error with the path of the man files (return back to the old method).

* Fri Feb 24 2006 Sir Pingus <pingus_77@yahoo.fr> 2.3.1-1fc4
- 2.3.1
- FFmpeg inside XdTV
- Add the possibility to compile with amr_nb & amr_wb

* Fri Dec 23 2005 Sir Pingus <pingus_77@yahoo.fr> - 2.3.0-1
- 2.3.0
- Compiled with --disable-divx4linux & neXtaw
- Spec file updated

* Sun Jul 03 2005 Sir Pingus <pingus_77@yahoo.fr> - 2.2.0-2
- add the xdtv_wizard menu entry

* Fri Jul 01 2005 Sir Pingus <pingus_77@yahoo.fr> - 2.2.0-1
- Upgrade to 2.2.0
- Compiled with --disable-divx4linux
- Spec file cleanup 

* Sun Apr 03 2005 Emmanuel Seyman <seyman@wanadoo.fr> - 2.1.1-1
- Upgrade to 2.1.1

* Sun Jan 02 2005 Emmanuel Seyman <seyman@wanadoo.fr> - 2.0.1-1
- Upgrade to 2.0.1
- Obsolete xawdecode
- Clean up installation instructions

* Fri Nov 28 2003 Emmanuel Seyman <seyman@wanadoo.fr> - 1.8.2-1
- Upgrade to 1.8.2

* Sat Oct 04 2003 Emmanuel Seyman <seyman@wanadoo.fr> - 1.8.1-1
- Upgrade to 1.8.1

* Tue Sep 02 2003 Emmanuel Seyman <seyman@wanadoo.fr> - 1.8.0-1
- Initial RPM release.
